package example3;

import java.util.List;

import com.logntw.eva.cdm.accessor.CollectionAccessor;
import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.EagerToGet;
import com.logntw.eva.orm.ORMapper;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefaultTableCreator;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;

public class ArrayIUSDExcample
{
	public static void main(String[] args) throws Exception
	{
		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("dbName");
		ORMappers mappers = DefoORMappers.getInstance(db);

		DefaultTableCreator.create(mappers, EntityO.class);
		DefaultTableCreator.create(mappers, EntityP.class);

		ORMapper<EntityO> mapperO = mappers.getMapper(EntityO.class);
		ORMapper<EntityP> mapperP = mappers.getMapper(EntityP.class);
		CollectionAccessor<EntityP> data2A = mapperP.getCollectionAccessor("data2");
		mappers.open();
		try
		{
			EntityP p1 = mapperP.newObject();
			p1.setId1(1);
			EntityP p2 = mapperP.newObject();
			p2.setId1(2);

			EntityO o1 = mapperO.newObject();
			o1.setId1(1);
			EntityO o2 = mapperO.newObject();
			o2.setId1(2);
			EntityO o3 = mapperO.newObject();
			o3.setId1(3);

			mapperP.insert(p1);
			mapperP.insert(p2);
			mappers.commit();

			mapperO.insert(o1);
			mapperO.insert(o2);
			mapperO.insert(o3);
			mappers.commit();

			data2A.insert(p1, 0, 0, o1); // insert
			data2A.insert(p1, 0, 1, o2); // insert
			mappers.commit();

			data2A.insert(p2, 0, 0, o1); // insert
			data2A.insert(p2, 0, 1, o2); // insert
			data2A.insert(p2, 0, 2, o3); // insert
			mappers.commit();

			data2A.delete(p1, 0, 1); // delete
			data2A.delete(p2, 0, 2); // delete
			mappers.commit();

			List<EntityP> list = mapperP.selectAll(EagerToGet.NONE); // select

			data2A.deleteAll(p1); // delete
			data2A.deleteAll(p2); // delete
			mappers.commit();

			mapperP.deleteAll(); // delete
			mapperO.deleteAll(); // delete
			mappers.commit();
		}
		finally
		{
			mappers.close();
			DefaultTableCreator.drop(mappers, EntityP.class);
			DefaultTableCreator.drop(mappers, EntityO.class);
		}
	}
}
