package example3;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import com.logntw.eva.odm.Condition;
import com.logntw.eva.odm.weighted.ConverterAtoB;
import com.logntw.eva.odm.weighted.WeightedConverter;
import com.logntw.eva.odm.weighted.ConverterAtoB.Access;

@ConverterAtoB(Access.BA_PRIVATE)
public final class CalendarStringConverter extends WeightedConverter<Calendar,String>
{
	private final static String FORMAT = "yyyy-MM-dd'T'HH:mm:ss.SSS"; 
	@Override
	public Calendar from(String object)
	{
		if(object == null)
			return null;
		Calendar calendar = Calendar.getInstance();
		try
		{
			calendar.setTime(new SimpleDateFormat(FORMAT).parse(object));
		}
		catch (ParseException e)
		{
			throw new java.lang.IllegalStateException(e.getMessage(), e);
		}
		return calendar;
	}

	@Override
	public Condition<Calendar> getInCondition()
	{
		return getCondition(Calendar.class);
	}

	@Override
	public Condition<String> getOutCondition()
	{
		return getCondition(String.class);
	}

	@Override
	public String to(Calendar data)
	{
		if(data == null)
			return null;
		return new SimpleDateFormat(FORMAT).format(data.getTime());
	}	
}