package example3;

import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.ORMSetting;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.DefoTableSetting;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;
import com.logntw.eva.table.TableSetting;
import com.logntw.eva.table.naming.DefaultTableColumnNaming;
import com.logntw.eva.table.naming.WithInnerNaming;

public class ChangeDefoNaming
{
	public void changeDefoNaming() throws Exception
	{
		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("databaseName");
		TableSetting tableSetting = DefoTableSetting.newInstance(db.getDialect());
		ORMSetting setting = new ORMSetting(tableSetting);

		WithInnerNaming tmp = (WithInnerNaming) tableSetting.columnNaming();
		DefaultTableColumnNaming naming = (DefaultTableColumnNaming) tmp.naming();

		naming.setDefaultEntityKey("{simpleName}");
		naming.setDefaultEntityName("{fullName}");
		naming.setDefaultCollectionKey("{owner.simpleName}_{owner.property}");
		naming.setDefaultCollectionName("{owner.name}_{owner.property}");
		naming.setDefaultColumnKey("{path}");
		naming.setDefaultColumnName("{path}");

		ORMappers mappers = DefoORMappers.getInstance(setting, db);
	}
}
