package example3;

import java.util.List;

import com.logntw.eva.cdm.accessor.CollectionAccessor;
import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.EagerToGet;
import com.logntw.eva.orm.ORMapper;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefaultTableCreator;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;

public class CollectionIUSDExample
{
	public static void main(String[] args) throws Exception
	{
		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("dbName");
		ORMappers mappers = DefoORMappers.getInstance(db);

		DefaultTableCreator.create(mappers, EntityO.class);
		ORMapper<EntityO> mapper = mappers.getMapper(EntityO.class);
		CollectionAccessor<List<List<Integer>>> data2A = mapper.getCollectionAccessor("data2");
		CollectionAccessor<List<Integer>> data2ValA = data2A.getCollectionAccessor("val");
		mappers.open();
		try
		{
			EntityO o1 = mapper.newObject();
			o1.setId1(1);
			EntityO o2 = mapper.newObject();
			o2.setId1(2);

			mapper.insert(o1);
			mapper.insert(o2);
			mappers.commit();

			List<List<Integer>> l1 = data2A.createCollection(o1);
			List<List<Integer>> l2 = data2A.createCollection(o2);
			List<Integer> ll1 = data2ValA.createCollection(l1);
			List<Integer> ll2 = data2ValA.createCollection(l2);

			l1.add(ll1); // insert			
			l2.add(ll2); // insert
			mappers.commit();

			ll1.add(10); // insert
			ll2.add(20); // insert
			mappers.commit();

			ll1.set(0, 30); // update
			ll2.set(0, 40); // update
			mappers.commit();

			List<EntityO> list = mapper.selectAll(EagerToGet.NONE); // select
			List<List<Integer>> o1Data2 = data2A.selectAll(o1, EagerToGet.NONE); // select

			ll1.clear(); // delete
			ll2.clear(); // delete
			mappers.commit();

			l1.clear(); // delete
			l2.clear(); // delete
			mappers.commit();

			mapper.deleteAll(); // delete
			mappers.commit();
		}
		finally
		{
			mappers.close();
			DefaultTableCreator.drop(mappers, EntityO.class);
		}
	}
}
