package example3;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Savepoint;

import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.sql.dialect.Dialect;

public class DisableTX_ConnectionProvider implements DBConnectionProvider
{
	private final DBConnectionProvider db;
	public DisableTX_ConnectionProvider(DBConnectionProvider db)
	{
		if(db == null)
			throw new java.lang.IllegalArgumentException();
		this.db = db;
	}
	
	@Override
	public Dialect getDialect()
	{
		return db.getDialect();
	}

	@Override
	public boolean commit(Connection connection) throws SQLException
	{
		return false;
	}

	@Override
	public void dispose()
	{
		db.dispose();
	}

	@Override
	public Connection getConnection() throws SQLException
	{
		return db.getConnection();
	}

	@Override
	public boolean releaseConnection(Connection connection) throws SQLException
	{
		return db.releaseConnection(connection);
	}

	@Override
	public boolean rollback(Connection connection) throws SQLException
	{		
		return false;
	}

	@Override
	public boolean rollback(Connection connection, Savepoint savepoint) throws SQLException
	{		
		return false;
	}

	@Override
	public boolean commit(Object key, Connection connection) throws SQLException
	{		
		return false;
	}

	@Override
	public Connection getConnection(Object key) throws SQLException
	{
		return db.getConnection(key);
	}

	@Override
	public boolean releaseConnection(Object key, Connection connection) throws SQLException
	{
		return db.releaseConnection(key, connection);
	}

	@Override
	public boolean rollback(Object key, Connection connection) throws SQLException
	{
		return false;
	}

	@Override
	public boolean rollback(Object key, Connection connection, Savepoint savepoint) throws SQLException
	{
		return false;
	}
}
