package example3;

import java.sql.SQLException;

import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.defo.conn.DB2_8ConnectionProvider;
import com.logntw.eva.orm.defo.conn.DerbyConnectionProvider;
import com.logntw.eva.orm.defo.conn.H2ConnectionProvider;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;
import com.logntw.eva.orm.defo.conn.MySQL_5ConnectionProvider;
import com.logntw.eva.orm.defo.conn.Oracle_10ConnectionProvider;
import com.logntw.eva.orm.defo.conn.SQLServer_2005ConnectionProvider;

public final class GetDBCProvider
{
	private GetDBCProvider()
	{

	}

	public static DBConnectionProvider getInstance(String dbType, String dbName) throws SQLException
	{
		if (dbType.startsWith("hsqldb"))
			return new HSQLDB_1_8ConnectionProvider(dbName);
		if (dbType.startsWith("h2"))
			return new H2ConnectionProvider(dbName);
		if (dbType.startsWith("derby"))
			return new DerbyConnectionProvider(dbName);
		if (dbType.startsWith("mysql"))
			return new MySQL_5ConnectionProvider("//IP/" + dbName, "id", "password");
		if (dbType.startsWith("db2"))
		{
			String url = "//IP:50000/" + dbName;
			return new DB2_8ConnectionProvider(url, "id", "password");
		}
		if (dbType.startsWith("sqlserver"))
		{
			String url = 
				"jdbc:sqlserver://IP;instanceName=SQLEXPRESS;databaseName=" + dbName;
			return new SQLServer_2005ConnectionProvider(url, "id", "password");
		}
		if (dbType.startsWith("oracle"))
		{
			String url = "jdbc:oracle:thin:id/password@IP:1521/" + dbName;
			return new Oracle_10ConnectionProvider(url);
		}
		return null;
	}
}
