package example3;

import java.util.Calendar;

import com.logntw.eva.odm.Condition;
import com.logntw.eva.odm.weighted.WeightedConverter;

public final class IntegerCalendarConverter extends WeightedConverter<Integer,Calendar>
{
	@Override
	public Integer from(Calendar object)
	{
		return object == null ? 0 : (int)object.getTimeInMillis();
	}

	@Override
	public Condition<Integer> getInCondition()
	{
		return getCondition(Integer.class);
	}

	@Override
	public Condition<Calendar> getOutCondition()
	{
		return getCondition(Calendar.class);
	}

	@Override
	public Calendar to(Integer data)
	{			
		if(data == null)
			return null;
		Calendar calendar = Calendar.getInstance();
		calendar.setTimeInMillis(data);
		return calendar;
	}
}