package example3;

import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.ORMapper;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefaultTableCreator;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;

import example2.EntityA;
import example2.EntityB;
import example2.EntityC;

public class ModifyingExample
{
	private ModifyingExample()
	{
	}

	public static void example() throws Exception
	{
		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("dbName");
		ORMappers mappers = DefoORMappers.getInstance(db);
		DefaultTableCreator.create(mappers, EntityC.class);
		DefaultTableCreator.create(mappers, EntityB.class);
		DefaultTableCreator.create(mappers, EntityA.class);

		ORMapper<EntityA> mapper = mappers.getMapper(EntityA.class);
		mappers.open();
		try
		{								
			EntityB entityB = mappers.newObject(EntityB.class);
			entityB.setId1(100);
			EntityA entityA = mapper.newModification();
			entityA.setData1(entityB);
			mapper.update(entityA, "data1.data2.data1 = ?", 50);			
		}
		finally
		{
			mappers.close();
			DefaultTableCreator.drop(mappers, EntityA.class);
			DefaultTableCreator.drop(mappers, EntityB.class);
			DefaultTableCreator.drop(mappers, EntityC.class);
		}
	}
}
