package example3;

import java.util.HashSet;

import collection.MySet;
import collection.MySetEntity;
import collection.MySetImp;

import com.logntw.eva.bean.condition.ConditionObj;
import com.logntw.eva.cdm.AbstractCollectionConverter;
import com.logntw.eva.cdm.element.ElementIterator;
import com.logntw.eva.condition.OP;
import com.logntw.eva.orm.CollectionMapper;
import com.logntw.eva.orm.EagerToGet;
import com.logntw.eva.sql.SelectOption;

public class MySetAccessor extends AbstractCollectionConverter<MySet, MySetEntity>
{
	@Override
	public Class<MySetEntity> entityType()
	{
		return MySetEntity.class;
	}

	@Override
	public boolean insert(CollectionMapper<MySetEntity> mapper, Object owner, Object element)
	{
		MySetEntity entity = mapper.newObject();
		entity.setVal(element);
		return mapper.insert(owner, entity);
	}

	@Override
	public boolean delete(CollectionMapper<MySetEntity> mapper, Object owner, Object element)
	{
		MySetEntity entity = mapper.newObject();
		entity.setVal(element);
		return mapper.delete(owner, true, entity);
	}

	private static class MyHashSet<T> extends HashSet<T> implements MySet<T>
	{

	}

	@Override
	public MySet createCollection(CollectionMapper<MySetEntity> mapper, Object owner)
	{
		MySet rtn = new MySetImp(mapper, owner, new MyHashSet());
		return rtn;
	}
	
	@Override
	public MySet createCollection(CollectionMapper<MySetEntity> mapper, Object owner,
			ElementIterator<MySetEntity> elements)
	{
		MySet set = new MyHashSet();
		MySetImp rtn = new MySetImp(mapper, owner, set);		
		try
		{
			for (MySetEntity entity : elements)
				set.add(entity.getVal());
		}
		finally
		{
			elements.dispose();
		}
		return rtn;
	}
	
	@Override
	public Iterable<MySetEntity> getElementIterator(CollectionMapper<MySetEntity> mapper, MySet collection)
	{
		MySetEntity entity = mapper.newObject();
		return new MySetImp.MySetEntityIterator(collection, entity);
	}

	@Override
	public MySet select(CollectionMapper<MySetEntity> mapper, Object owner, boolean byKey, EagerToGet eager,
			ConditionObj condition, SelectOption option)
	{
		MySet set = new MyHashSet();
		MySetImp rtn = new MySetImp(mapper, owner, set);
		ConditionObj<MySetEntity> cobj = mapper.newCondition();
		cobj.If(OP.THAT).setVal(condition);
		ElementIterator<MySetEntity> iterator = mapper.select(owner, byKey, eager, cobj, option);
		try
		{
			for (MySetEntity entity : iterator)
				set.add(entity.getVal());
		}
		finally
		{
			iterator.dispose();
		}
		return rtn;
	}

	@Override
	public MySet selectAll(CollectionMapper<MySetEntity> mapper, Object owner, EagerToGet eager, SelectOption option)
	{
		MySet set = new MyHashSet();
		MySetImp rtn = new MySetImp(mapper, owner, set);
		ElementIterator<MySetEntity> iterator = mapper.selectAll(owner, false, eager, option);
		try
		{
			for (MySetEntity entity : iterator)
				set.add(entity.getVal());
		}
		finally
		{
			iterator.dispose();
		}
		return rtn;
	}

	@Override
	public int count(CollectionMapper<MySetEntity> mapper, Object owner, boolean byKey, ConditionObj condition)
	{
		ConditionObj<MySetEntity> cobj = mapper.newCondition();
		cobj.If(OP.THAT).setVal(condition);
		return mapper.count(owner, byKey, cobj);
	}
}
