package example3;

import java.util.HashMap;
import java.util.Map;

import com.logntw.eva.orm.EagerToGet;
import com.logntw.eva.orm.ORMappers;

public final class ObjectCache
{
	private final Map<Object,Object> cache = new HashMap<Object,Object>();
	public <T> T getEntity(ORMappers mappers, T query)
	{
		Object rtn = cache.get(query);
		if(rtn != null)
			return (T)rtn;
		rtn = mappers.selectThis(true, EagerToGet.NONE, query);
		cache.put(query, rtn);
		return (T)rtn;
	}
	
	public <T> T getProperty(T property)
	{
		Object rtn = cache.get(property);
		if(rtn != null)
			return (T)rtn;
		cache.put(property, property);
		return property;
	}
}
