package example3;

import com.logntw.eva.odm.Condition;
import com.logntw.eva.odm.weighted.ConverterAtoB;
import com.logntw.eva.odm.weighted.WeightedConverter;
import com.logntw.eva.odm.weighted.ConverterAtoB.Access;

@ConverterAtoB(Access.BA_PRIVATE)
public class StudentIDConverter extends WeightedConverter<StudentID, Long>
{
	@Override
	public StudentID from(Long object)
	{				
		long val = object;
		StudentID rtn = new StudentID();
		rtn.setDepartment((char)(val >> 32));
		rtn.setSerial((int)(val & 0x00000000FFFFFFFFl));
		return rtn;
	}

	@Override
	public Condition<StudentID> getInCondition()
	{
		return getCondition(StudentID.class);
	}

	@Override
	public Condition<Long> getOutCondition()
	{
		return getCondition(Long.class);
	}

	@Override
	public Long to(StudentID data)
	{
		long rtn = (long)data.getDepartment() << 32;
		rtn |= (data.getSerial() & 0x00000000FFFFFFFFl);
		return rtn;
	}
}
