package example3;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Savepoint;

import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.sql.dialect.Dialect;

public class TwoDBConnectionProvider implements DBConnectionProvider
{
	private final DBConnectionProvider Taipei;
	private final DBConnectionProvider Kaohsiung;

	public TwoDBConnectionProvider(DBConnectionProvider Taipei, DBConnectionProvider Kaohsiung)
	{
		if(Taipei == null || Kaohsiung == null 
				|| !Taipei.getDialect().equals(Kaohsiung.getDialect()))
			throw new java.lang.IllegalArgumentException();
		this.Taipei = Taipei;
		this.Kaohsiung = Kaohsiung;		
	}
	
	@Override
	public Dialect getDialect()
	{
		return Taipei.getDialect();
	}

	@Override
	public Connection getConnection(Object key) throws SQLException
	{		
		if(key==(Integer)02)
			return Taipei.getConnection();
		else if(key==(Integer)07)
			return Kaohsiung.getConnection();
		else
			throw new java.lang.IllegalStateException();
	}
	
	@Override
	public boolean commit(Object key, Connection connection) throws SQLException
	{
		if(key==(Integer)02)
			return Taipei.commit(connection);
		else if(key==(Integer)07)
			return Kaohsiung.commit(connection);
		else
			throw new java.lang.IllegalStateException();
	}

	@Override
	public boolean rollback(Object key, Connection connection) throws SQLException
	{
		if(key==(Integer)02)
			return Taipei.rollback(connection);
		else if(key==(Integer)07)
			return Kaohsiung.rollback(connection);
		else
			throw new java.lang.IllegalStateException();
	}

	@Override
	public boolean rollback(Object key, Connection connection, Savepoint savepoint) throws SQLException
	{
		if(key==(Integer)02)
			return Taipei.rollback(connection, savepoint);
		else if(key==(Integer)07)
			return Kaohsiung.rollback(connection, savepoint);
		else
			throw new java.lang.IllegalStateException();
	}

	@Override
	public boolean releaseConnection(Object key, Connection connection) throws SQLException
	{
		if(key==(Integer)02)
			return Taipei.releaseConnection(connection);
		else if(key==(Integer)07)
			return Kaohsiung.releaseConnection(connection);
		else
			throw new java.lang.IllegalStateException();
	}
	
	@Override
	public Connection getConnection() throws SQLException
	{
		return Taipei.getConnection();
	}
	
	@Override
	public boolean commit(Connection connection) throws SQLException
	{
		return Taipei.commit(connection);
	}

	@Override
	public boolean rollback(Connection connection) throws SQLException
	{
		return Taipei.rollback(connection);
	}

	@Override
	public boolean rollback(Connection connection, Savepoint savepoint) throws SQLException
	{
		return Taipei.rollback(connection, savepoint);
	}
	
	@Override
	public boolean releaseConnection(Connection connection) throws SQLException
	{
		return Taipei.releaseConnection(connection);
	}
	
	@Override
	public void dispose()
	{
		Taipei.dispose();
		Kaohsiung.dispose();
	}
}
