package example3;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Savepoint;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;

import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;
import com.logntw.eva.orm.imp.DBConnectionProviderImpFactory;

public class WS_HSQLDB_1_8ConnectionProvider extends HSQLDB_1_8ConnectionProvider
{	
	public WS_HSQLDB_1_8ConnectionProvider(String databaseName, String id, String password) throws SQLException
	{
		super(databaseName, id, password);
	}
	
	public WS_HSQLDB_1_8ConnectionProvider(String databaseNameOrURI) throws SQLException
	{
		super(databaseNameOrURI);
	}
	
	public WS_HSQLDB_1_8ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseName, String id, String password) throws SQLException
	{
		super(factory, databaseName, id, password);
	}
	
	public WS_HSQLDB_1_8ConnectionProvider(DBConnectionProviderImpFactory factory, String databaseNameOrURI) throws SQLException
	{
		super(factory, databaseNameOrURI);
	}
	
	private final ConcurrentMap<Object, Connection> connections = new ConcurrentHashMap<Object, Connection>();
	@Override
	public Connection getConnection(Object key)throws SQLException
	{
		Connection connection = connections.get(key);
		if(connection != null)
			return connection;
		synchronized(connections) // or synchronized(key)
		{
			connection = connections.get(key);
			if(connection != null)
				return connection;
			connection = imp.getConnection();
			connections.put(key, connection);
		}
		return connection;
	}
		
	@Override
	public boolean commit(Object key, Connection connection) throws SQLException
	{
		return true;
	}

	@Override
	public boolean rollback(Object key, Connection connection) throws SQLException
	{
		return true;
	}

	@Override
	public boolean rollback(Object key, Connection connection, Savepoint savepoint) throws SQLException
	{
		return true;
	}

	@Override
	public boolean releaseConnection(Object key, Connection connection) throws SQLException
	{
		connections.remove(key);
		return imp.releaseConnection(connection);
	}	
}
