package example4;

import com.logntw.eva.anno.bean.Dimension;
import com.logntw.eva.anno.bitstruct.BitStruct;
import com.logntw.eva.anno.bitstruct.Bits;
import com.logntw.eva.anno.struct.Bytes;
import com.logntw.eva.anno.struct.FieldSeq;
import com.logntw.eva.anno.struct.Struct;

@Struct
public interface NTPMsg
{
	@BitStruct
	public static interface LVM
	{
		//unsigned 
		@FieldSeq(1)
		@Bits(3)
		byte getMode();
		void setMode(byte c);
		
		//unsigned
		@FieldSeq(2)
		@Bits(3)
		byte getVn();
		void setVn(byte vn);
		
		//unsigned 
		@FieldSeq(3)
		@Bits(2)
		byte getLi();
		void setLi(byte li);
	}
	
	@FieldSeq(1)
	LVM getLVM();
	void setLVM(LVM lvm);

	@FieldSeq(2)
	//unsigned byte
	@Bytes(1)
	short getStratum();
	void setStratum(short stratum);
	
	@FieldSeq(3)
	byte getPoll();
	void setPoll(byte poll);
	
	@FieldSeq(4)
	byte getPrecision();
	void setPrecision(byte precision);
	
	@FieldSeq(5)
	//unsigned int
	@Bytes(4)
	long getRoot_delay();
	void setRoot_delay(long root_delay);
	
	@FieldSeq(6)
	//unsigned int
	@Bytes(4)
	long getRoot_dispersion();
	void setRoot_dispersion(long root_dispersion);
	
	@FieldSeq(7)
	//unsigned int
	@Dimension(4)
	byte[] getReference_identifier();
	void setReference_identifier(byte[] reference_identifier);
			
	@FieldSeq(8)
	//unsigned int
	@Bytes(4)
	long getReference_timestamp_secs();
	void setReference_timestamp_secs(long reference_timestamp_secs);
	
	@FieldSeq(9)
	//unsigned int
	@Bytes(4)
	long getReference_timestamp_fraq();
	void setReference_timestamp_fraq(long reference_timestamp_fraq);
	
	@FieldSeq(10)
	//unsigned int
	@Bytes(4)
	long getOriginate_timestamp_secs();
	void setOriginate_timestamp_secs(long originate_timestamp_secs);
	
	@FieldSeq(11)
	//unsigned int
	@Bytes(4)
	long getOriginate_timestamp_fraq();
	void setOriginate_timestamp_fraq(long originate_timestamp_fraq);
	
	@FieldSeq(12)
	//unsigned int
	@Bytes(4)
	long getReceive_timestamp_secs();
	void setReceive_timestamp_secs(long receive_timestamp_seqs);
	
	@FieldSeq(13)
	//unsigned int
	@Bytes(4)
	long getReceive_timestamp_fraq();
	void setReceive_timestamp_fraq(long receive_timestamp_fraq);
	
	@FieldSeq(14)
	//unsigned int
	@Bytes(4)
	long getTransmit_timestamp_secs();
	void setTransmit_timestamp_secs(long transmit_timestamp_secs);
	
	@FieldSeq(15)
	//unsigned int
	@Bytes(4)
	long getTransmit_timestamp_fraq();
	void setTransmit_timestamp_fraq(long transmit_timestamp_fraq);
}