package example5;

import java.util.List;

import com.logntw.eva.ioc.DefoObjectFactory;
import com.logntw.eva.ioc.ObjectFactory;
import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefaultTableCreator;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;

import example2.EntityC;

public abstract class AOPORM
{
	@QueryByCondition(entity=EntityC.class, condition="id1=?")
	public abstract List<EntityC> selectById1(int id1);
	
	@Update(entity=EntityC.class, stmt="INSERT INTO $EntityC(id1,data1) VALUES(?,100)")
	public abstract int insertById1(int id1);
	
	
	public static void main(String[] args) throws Exception
	{
		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("dbName");
		ORMappers mappers = DefoORMappers.getInstance(db);
		DefaultTableCreator.create(mappers, EntityC.class);
		
		ObjectFactory objFactory = DefoObjectFactory.getInstance();
		ORMMonitor monitor = objFactory.getInstance(ORMMonitor.class, mappers);
		objFactory.setObjectMonitor(monitor);
		
		AOPORM obj = objFactory.getInstance(AOPORM.class);
				
		obj.insertById1(10);
		List<EntityC> result = obj.selectById1(10);
		
		DefaultTableCreator.drop(mappers, EntityC.class);		
	}
}