package example5;

import com.logntw.eva.ioc.DefoObjectFactory;
import com.logntw.eva.ioc.ObjectFactory;
import com.logntw.eva.ioc.aop.ObjectMonitor;
import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.EagerToGet;
import com.logntw.eva.orm.ORMapper;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefaultTableCreator;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;

import example2.EntityC;

public class AOPTransaction
{
	@Transactional
	public void databaseIO(ORMappers mappers)
	{
		ORMapper<EntityC> mapper = mappers.getMapper(EntityC.class);
		
		EntityC entityC = mapper.newObject();
		entityC.setId1(10);
		entityC.setData1(20);

		mapper.insert(entityC); // INSERT

		EntityC mEntityC = mapper.shallowCopy(entityC);
		mEntityC.setId1(30);
		mEntityC.setData1(40);
		mapper.update(true, mEntityC); // UPDATE
		
		EntityC that = mapper.selectOne(EagerToGet.NONE, "id1=?", 30); // SELECT
		mapper.delete(true, that); // DELETE			
	}
	
	
	public static void main(String[] args) throws Exception
	{
		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("dbName");
		ORMappers mappers = DefoORMappers.getInstance(db);
		DefaultTableCreator.create(mappers, EntityC.class);
		
		ObjectFactory objFactory = DefoObjectFactory.getInstance();
		ObjectMonitor monitor = objFactory.getInstance(TransactionMonitor.class);
		objFactory.setObjectMonitor(monitor);		
		AOPTransaction io = objFactory.getInstance(AOPTransaction.class);
		io.databaseIO(mappers);
		
		DefaultTableCreator.drop(mappers, EntityC.class);		
	}
}
