package example5;

import java.lang.reflect.Method;

import com.logntw.eva.anno.ioc.aop.Classes;
import com.logntw.eva.anno.ioc.aop.Methods;
import com.logntw.eva.anno.ioc.aop.WatchConstructors;
import com.logntw.eva.anno.ioc.aop.WatchMethods;
import com.logntw.eva.ioc.aop.Advice;
import com.logntw.eva.ioc.aop.ObjectMonitor;

public class MockMonitor implements ObjectMonitor
{
	@Override
	public void onMethodCannotBeMonitored(Method m)
	{		
		throw new java.lang.IllegalStateException();
	}

	@Override
	public void onClassCannotBeMonitored(Class<?> clz)
	{
		throw new java.lang.IllegalStateException();	
	}	
	
	private int invocations = 0;
	public int invocations()
	{
		return invocations;
	}
	@WatchMethods
	(
		clz=@Classes(pattern="example4.\\S*"), 
		method=@Methods()
	)		
	public void onMethodInvoked(Advice advice, Object... paras)
	{
		invocations ++;
	}
	
	private int creations = 0;
	public int creations()
	{
		return creations;
	}
	@WatchConstructors
	(
		clz=@Classes(pattern="example4.\\S*")
	)		
	public void onObjectCreate(Advice advice, Object... paras)
	{						
		creations ++;
	}
}
