package example5;

import java.lang.reflect.Method;

import com.logntw.eva.anno.ioc.aop.Classes;
import com.logntw.eva.anno.ioc.aop.Methods;
import com.logntw.eva.anno.ioc.aop.WatchMethods;
import com.logntw.eva.ioc.aop.Advice;
import com.logntw.eva.ioc.aop.ObjectMonitor;
import com.logntw.eva.ioc.aop.When;
import com.logntw.eva.ioc.aop.Advice.Reaction;

public class ParasMonitor implements ObjectMonitor
{
	@Override
	public void onMethodCannotBeMonitored(Method m)
	{		
		throw new java.lang.IllegalStateException();
	}

	@Override
	public void onClassCannotBeMonitored(Class<?> clz)
	{
		throw new java.lang.IllegalStateException();	
	}	
		
	private boolean onNullPara(Advice advice)
	{
		advice.setException(new IllegalArgumentException("Parameter null."));
		advice.setReaction(Reaction.THROW_EXCEPTION_NOW);
		return false;
	}
	
	@WatchMethods
	(
		clz=@Classes(pattern="example4.\\S*"), 
		method = @Methods(with={NoNullPara.class})
	)		
	public boolean onMethodInvoked(Advice advice, Object... paras)
	{
		if(paras == null)
			return onNullPara(advice);
				
		for(Object para : paras)
		{
			if(para == null)				
				return onNullPara(advice);				
			if(para.getClass().isArray() && !onMethodInvoked(advice, (Object[])para))
				return false;
		}
		return true;							
	}
	
	@WatchMethods
	(
		clz=@Classes(pattern="example4.\\S*"), 
		method = @Methods(with={NoNullPara.class}),
		when = When.AFTER
	)		
	public void onMethodReturned(Advice advice, Object... paras)
	{
		if(advice.getReturnedValue() == null && !void.class.equals(advice.getMethod().getReturnType()))
			onNullPara(advice);				
	}
}
