package example5;

import java.lang.reflect.Method;

import com.logntw.eva.anno.ioc.aop.Classes;
import com.logntw.eva.anno.ioc.aop.Methods;
import com.logntw.eva.anno.ioc.aop.WatchMethods;
import com.logntw.eva.ioc.aop.Advice;
import com.logntw.eva.ioc.aop.ObjectMonitor;
import com.logntw.eva.ioc.aop.When;
import com.logntw.eva.ioc.aop.Advice.Reaction;
import com.logntw.eva.orm.ORMappers;

public class TransactionMonitor implements ObjectMonitor
{
	@Override
	public void onClassCannotBeMonitored(Class<?> clz)
	{
		throw new java.lang.IllegalStateException();
	}

	@Override
	public void onMethodCannotBeMonitored(Method method)
	{
		throw new java.lang.IllegalStateException();
	}

	@WatchMethods(clz = @Classes(pattern = "\\S*"), method = @Methods(with={Transactional.class}), when = When.BEFORE)
	public void onTransactionStart(Advice advice, Object... paras)
	{
		if(paras.length == 0 || !(paras[0] instanceof ORMappers))
		{
			advice.setException(new java.lang.IllegalStateException());
			advice.setReaction(Reaction.THROW_EXCEPTION_NOW);
			return;
		}
		ORMappers mappers = (ORMappers)paras[0];
		mappers.open();		
	}
	
	@WatchMethods(clz = @Classes(pattern = "\\S*"), method = @Methods(with={Transactional.class}), when = When.AFTER)
	public void onTransactionEnd(Advice advice, Object... paras)
	{
		ORMappers mappers = (ORMappers)paras[0];
		if(advice.getException() != null)
		{
			mappers.rollback();
			mappers.close();
		}
		else
		{
			mappers.commit();
			mappers.close();
		}
	}
}
