package example7;

import java.util.ArrayList;
import java.util.List;

import com.logntw.eva.bean.condition.ConditionObj;
import com.logntw.eva.cache.QueriedResultCache;
import com.logntw.eva.cache.SortedMapProvider;
import com.logntw.eva.cache.defo.DefoCacheSpaceProvider;
import com.logntw.eva.cache.defo.DefoQueriedResultCache;
import com.logntw.eva.condition.OP;
import com.logntw.eva.orm.DBConnectionProvider;
import com.logntw.eva.orm.ORMapper;
import com.logntw.eva.orm.ORMappers;
import com.logntw.eva.orm.defo.DefaultTableCreator;
import com.logntw.eva.orm.defo.DefoORMappers;
import com.logntw.eva.orm.defo.conn.HSQLDB_1_8ConnectionProvider;

public class QueriedResultCacheExample
{
	public static void main(String[] args) throws Exception
	{
		SortedMapProvider imp = DefoCacheSpaceProvider.getProvider();
		QueriedResultCache cache = new DefoQueriedResultCache(imp);

		DBConnectionProvider db = new HSQLDB_1_8ConnectionProvider("dbName");
		ORMappers mappers = DefoORMappers.getInstance(db);
		DefaultTableCreator.create(mappers, EntityS.class);
		ORMapper<EntityS> mapper = mappers.getMapper(EntityS.class);

		EntityS s1 = mapper.newObject();
		s1.setId1("A");
		s1.setId2(3);
		EntityS s2 = mapper.newObject();
		s2.setId1("strAB");
		s2.setId2(3);
		EntityS s3 = mapper.newObject();
		s3.setId1("strC");
		s3.setId2(4);
		EntityS s4 = mapper.newObject();
		s4.setId1("str");
		s4.setId2(5);
		EntityS s5 = mapper.newObject();
		s5.setId1("strD");
		s5.setId2(6);
		EntityS s6 = mapper.newObject();
		s6.setId1("B");
		s6.setId2(7);
		EntityS s7 = mapper.newObject();
		s7.setId1("sTrE");
		s7.setId2(5);
		EntityS s8 = mapper.newObject();
		s8.setId1("000");
		s8.setId2(4);
		EntityS s9 = mapper.newObject();
		s9.setId1("str");
		s9.setId2(4);

		List<EntityS> list = new ArrayList<EntityS>();
		list.add(s1);
		list.add(s2);
		list.add(s3);
		list.add(s4);
		list.add(s5);
		list.add(s6);
		list.add(s7);
		list.add(s8);
		list.add(s9);

		ConditionObj<EntityS> c1 = mapper.newCondition();
		c1.If(OP.GREATER_OR_EQUAL).setId2(3);

		cache.insert(c1, list); // C1 -> S1, S2, S3, S4, S5, S6, S7, S8, S9

		ConditionObj<EntityS> c2 = mapper.newCondition();
		c2.If(OP.GREATER).setId2(3);
		c2.If(OP.LIKE).setId1("str%");

		ConditionObj<EntityS> c3 = mapper.newCondition();
		c3.If(OP.LESS).setId2(5);

		ConditionObj<EntityS> c4 = mapper.newCondition();
		c4.If(OP.NOT_EQUAL).setId2(5);

		ConditionObj<EntityS> c5 = mapper.newCondition();
		c5.If(OP.GREATER).setId2(3);
		c5.If(OP.NOT_LIKE).setId1("str%");

		List<EntityS> rtn;
		rtn = cache.select(c3); // null
		rtn = cache.select(c4); // null

		rtn = cache.select(c2); //S3, S4, S5, S9
		rtn = cache.select(c2, 0, 3); // S3, S4, S5

		cache.insert(c2, cache.select(c2)); // C2 -> S3, S4, S5, S9
		cache.update(s6); // Remove C1's record
		rtn = cache.select(c2); // S3, S4, S5, S9
		rtn = cache.select(c5);
		cache.update(s4); // Remove C2's record
		rtn = cache.select(c2); // null		
	}
}
